/**********************************************************************************
* Blueprint Reality Inc. CONFIDENTIAL
* 2020 Blueprint Reality Inc.
* All Rights Reserved.
*
* NOTICE:  All information contained herein is, and remains, the property of
* Blueprint Reality Inc. and its suppliers, if any.  The intellectual and
* technical concepts contained herein are proprietary to Blueprint Reality Inc.
* and its suppliers and may be covered by Patents, pending patents, and are
* protected by trade secret or copyright law.
*
* Dissemination of this information or reproduction of this material is strictly
* forbidden unless prior written permission is obtained from Blueprint Reality Inc.
***********************************************************************************/

#if UNITY_STANDALONE_WIN
using BlueprintReality.MixCast.Data;
using BlueprintReality.MixCast.Shared;
using UnityEngine;

namespace BlueprintReality.MixCast
{
    public static class SdkCameraUtilities
    {
        public static bool IsCameraRunningInRealtime(string cameraId)
        {
            return IsCameraDisplayingToDesktop(cameraId) || IsCameraRecording(cameraId) || IsCameraStreaming(cameraId);
        }
        static bool IsCameraDisplayingToDesktop(string cameraId)
        {
            for (int i = 0; i < MixCastSdkData.Desktop.DisplayingCameraIds.Count; i++)
                if (MixCastSdkData.Desktop.DisplayingCameraIds[i] == cameraId)
                    return true;

            return false;
        }
        public static bool IsCameraRecording(string cameraId)
        {
            for (int i = 0; i < MixCastSdkData.Cameras.Count; i++)
                if (MixCastSdkData.Cameras[i].Identifier == cameraId)
                    return MixCastSdkData.Cameras[i].VideoRecordingEnabled;

            return false;
        }
        public static bool IsCameraStreaming(string cameraId)
        {
            for (int i = 0; i < MixCastSdkData.Cameras.Count; i++)
                if (MixCastSdkData.Cameras[i].Identifier == cameraId)
                    return MixCastSdkData.Cameras[i].VideoStreamingEnabled;

            return false;
        }
    }
}
#endif
