/**********************************************************************************
* Blueprint Reality Inc. CONFIDENTIAL
* 2020 Blueprint Reality Inc.
* All Rights Reserved.
*
* NOTICE:  All information contained herein is, and remains, the property of
* Blueprint Reality Inc. and its suppliers, if any.  The intellectual and
* technical concepts contained herein are proprietary to Blueprint Reality Inc.
* and its suppliers and may be covered by Patents, pending patents, and are
* protected by trade secret or copyright law.
*
* Dissemination of this information or reproduction of this material is strictly
* forbidden unless prior written permission is obtained from Blueprint Reality Inc.
***********************************************************************************/

#if UNITY_EDITOR_WIN || UNITY_STANDALONE_WIN
using System;
using System.IO;
using System.Text.RegularExpressions;

namespace BlueprintReality.MixCast.Windows
{
    public static partial class SpecialFolders
    {
        #region Documents
        //Documents/
        //  MixCast/
        //    Config

        public const string PRODUCT_NAME = "MixCast";

        public const string CONFIG_FOLDER_NAME = "Config";

        private static string myDocumentsFolder;
        public static string MyDocumentsFolder
        {
            get
            {
                if (myDocumentsFolder == null)
                    myDocumentsFolder = Environment.GetFolderPath(Environment.SpecialFolder.MyDocuments);
                return myDocumentsFolder;
            }
        }

        public static string MainFolder
        {
            get
            {
                return Path.Combine(MyDocumentsFolder, PRODUCT_NAME);
            }
        }
        public static string ConfigsPath
        {
            get
            {
                return Path.Combine(MainFolder, CONFIG_FOLDER_NAME);
            }
        }
        #endregion
    }
}
#endif
